#include <ccbg/CCMol.h>
#include <string>
#include <vector>

double string2double(string s);

//Protein atom definition
int get_type(string res, string atm);

//Ligand atom definition
int get_type2(string p);

//Calculate energies for water molecules interacted with ligand atoms
double pmf_lig(CCMol& m1, double x, double y, double z, vector<double> pmf_l, double c1, double c2);

//Calculate energies for water molecules interacted with protein atoms
double pmf_pro(CCMol& m1, double x, double y, double z, vector<double> pmf_p, double c1, double c2);

//Calculate energies for water molecules interacted with other water molecules
double pmf_wat(double x, double y, double z, double x2, double y2, double z2, vector<double> pmf_w, double c1, double c2);

//Calculate energy/entropy contributions by displaced water molecules
double sol_ene(CCMol& m1, vector<double> h_x, vector<double> h_y, vector<double> h_z, double d0, vector<double> pmf);

//Calculate the reference pmf energy from the solvent molecules which replace the protein atoms
double pmf_rep(CCMol& m1, double x, double y, double z, double cut, vector<double> pmf_w, double c1, double c2);

void swap(double *x, double *y);

void sort_vetex(double *x, double *y, double *z, double *pmf, double *d, int n);

double intpol_f(double a, double b, double r, double d);

double get_pmf(double *g_x, double *g_y, double *g_z, double *g_pmf, double x, double y, double z, double r);

string findMean(double x0, double y0, double z0, vector<string> id, vector<double> x, vector<double> y, vector<double> z);

double getcoord(vector<double> x, vector<string> id, string a);
